| The Gaudi Framework v29r0 (ff2e7097)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
RootHistCnv::RRWNTupleCnv Class Reference

Row wise NTuple converter class definition. More...

`#include <src/RRWNTupleCnv.h>`

Inheritance diagram for RootHistCnv::RRWNTupleCnv:
[legend]
Collaboration diagram for RootHistCnv::RRWNTupleCnv:
[legend]

## Public Member Functions
| RRWNTupleCnv (ISvcLocator *svc)
| Standard constructor. More...
| ~RRWNTupleCnv () override=default
| Standard destructor. More...
Public Member Functions inherited from RootHistCnv::RNTupleCnv
StatusCode | initialize () override
| Initialize the converter. More...
StatusCode | finalize () override
| Finalize the converter. More...
StatusCode | createObj (IOpaqueAddress *pAddr, DataObject *&refpObj) override
| Create the transient representation of an object. More...
StatusCode | updateObj (IOpaqueAddress *pAddr, DataObject *refpObj) override
| Update the transient object from the other representation. More...
StatusCode | createRep (DataObject *pObj, IOpaqueAddress *&refpAddr) override
| Convert the transient object to the requested representation. More...
StatusCode | updateRep (IOpaqueAddress *pAddr, DataObject *pObj) override
| Update the converted representation of a transient object. More...
Public Member Functions inherited from RootHistCnv::RConverter
StatusCode | createRep (DataObject *pObj, IOpaqueAddress *&refpAddr) override
| Convert the transient object to the requested representation. More...
long | repSvcType () const override
StatusCode | error (const std::string &msg)
StatusCode | regTFile (const std::string, const TFile *)
StatusCode | findTFile (const std::string, TFile *&)
std::string | diskDirectory (const std::string &loc)
std::string | directory (const std::string &loc)
void | setDirectory (const std::string &loc)
void | setDiskDirectory (const std::string &loc)
StatusCode | createDirectory (const std::string &loc)
StatusCode | createDiskDirectory (const std::string &loc)
std::string | getDirectory ()
std::string | convertId (const std::string &) const
Public Member Functions inherited from Converter
StatusCode | initialize () override
| Initialize the converter. More...
StatusCode | finalize () override
| Initialize the converter. More...
StatusCode | setDataProvider (IDataProviderSvc *svc) override
| Set Data provider service. More...
SmartIF< IDataProviderSvc > & | dataProvider () const override
| Get Data provider service. More...
StatusCode | setConversionSvc (IConversionSvc *svc) override
| Set conversion service the converter is connected to. More...
SmartIF< IConversionSvc > & | conversionSvc () const override
| Get conversion service the converter is connected to. More...
StatusCode | setAddressCreator (IAddressCreator *creator) override
| Set address creator facility. More...
SmartIF< IAddressCreator > & | addressCreator () const override
| Retrieve address creator facility. More...
const CLID & | objType () const override
| Retrieve the class type of objects the converter produces. More...
virtual long | i_repSvcType () const
| Retrieve the class type of the data store the converter uses. More...
StatusCode | createObj (IOpaqueAddress *pAddress, DataObject *&refpObject) override
| Create the transient representation of an object. More...
StatusCode | fillObjRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Resolve the references of the created transient object. More...
StatusCode | updateObj (IOpaqueAddress *pAddress, DataObject *refpObject) override
| Update the transient object from the other representation. More...
StatusCode | updateObjRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the references of an updated transient object. More...
StatusCode | createRep (DataObject *pObject, IOpaqueAddress *&refpAddress) override
| Convert the transient object to the requested representation. More...
StatusCode | fillRepRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Resolve the references of the converted object. More...
StatusCode | updateRep (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the converted representation of a transient object. More...
StatusCode | updateRepRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the references of an already converted object. More...
| Converter (long storage_type, const CLID &class_type, ISvcLocator *svc=0)
| Standard Constructor. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &type, const std::string &name, T *&psvc) const
| Access a service by name, type creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true) const
| Return a pointer to the service identified by name (or "type/name") More...
Public Member Functions inherited from implements< IConverter >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| implements ()=default
| Default constructor. More...
| implements (const implements &)
| Copy constructor (zero the reference count) More...
implements & | operator= (const implements &)
| Assignment operator (do not touch the reference count). More...
| ~implements () override=default
| Virtual destructor. More...
unsigned long | addRef () override
| Reference Interface instance. More...
unsigned long | release () override
| Release Interface instance. More...
unsigned long | refCount () const override
| Current reference count. More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Static Public Member Functions
static const CLID & | classID ()
| Inquire class type. More...
Static Public Member Functions inherited from RootHistCnv::RConverter
static long | storageType ()
| Inquire storage type. More...

## Protected Member Functions
StatusCode | load (TTree *tree, INTuple *&refpObject) override
| Create the transient representation of an object. More...
StatusCode | book (const std::string &desc, INTuple *pObject, TTree *&tree) override
| Book the N tuple. More...
StatusCode | writeData (TTree *rtree, INTuple *pObject) override
| Write N tuple data. More...
StatusCode | readData (TTree *rtree, INTuple *pObject, long ievt) override
| Read N tuple data. More...
Protected Member Functions inherited from RootHistCnv::RNTupleCnv
| RNTupleCnv (ISvcLocator *svc, const CLID &clid)
| Standard constructor. More...
| ~RNTupleCnv () override=default
| Standard destructor. More...
virtual std::string | rootVarType (int)
| Return ROOT type info: More...
Protected Member Functions inherited from RootHistCnv::RConverter
| RConverter (const CLID &clid, ISvcLocator *svc)
| Standard constructor. More...
| ~RConverter () override=default
| Standard destructor. More...
virtual StatusCode | readObject (IOpaqueAddress *pAddr, DataObject *&refpObj)
| Create the transient representation of an object. More...
virtual TObject * | createPersistent (DataObject *pObj)
| Create the persistent representation of an object. More...
StatusCode | createAddress (DataObject *pObject, TDirectory *pDir, TObject *pTObject, IOpaqueAddress *&refpAddr)
| Create address of the transient object according to the requested representation. More...
StatusCode | createAddress (const std::string &rzdir, const CLID &clid, long id, TObject *pTobj, IOpaqueAddress *&refpAddress)
StatusCode | createAddress (const std::string &rzdir, const CLID &clid, const std::string &title, TObject *pTobj, IOpaqueAddress *&refpAddress)
TDirectory * | changeDirectory (DataObject *pObject)
| Switch to object directory (=Parent directory) More...
Protected Member Functions inherited from Converter
| ~Converter () override=default
| Standard Destructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const
| Retrieve pointer to service locator. More...
SmartIF< IMessageSvc > & | msgSvc () const
| Retrieve pointer to message service. More...
SmartIF< IDataManagerSvc > & | dataManager () const
| Get Data Manager service. More...

## Additional Inherited Members
Public Types inherited from Converter
typedef Gaudi::PluginService::Factory< IConverter *, ISvcLocator * > | Factory
Public Types inherited from implements< IConverter >
using | base_class = implements< Interfaces... >
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
using | iids = typename extend_interfaces_base::ext_iids
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Attributes inherited from RootHistCnv::RNTupleCnv
SmartIF< INTupleSvc > | m_ntupleSvc
| Reference to N tuple service. More...
Protected Attributes inherited from implements< IConverter >
std::atomic_ulong | m_refCount
| Reference counter. More...

## Detailed Description

Row wise NTuple converter class definition.

Author
  Charles Leggett

Definition at line 18 of file RRWNTupleCnv.h.

## Constructor & Destructor Documentation

RootHistCnv::RRWNTupleCnv::RRWNTupleCnv | ( | ISvcLocator * | svc | ) |
| inline

Standard constructor.

Definition at line 24 of file RRWNTupleCnv.h.

24 : RNTupleCnv( svc, classID() ) {}
RootHistCnv::RNTupleCnv::RNTupleCnv
RNTupleCnv(ISvcLocator *svc, const CLID &clid)
Standard constructor.
Definition: RNTupleCnv.cpp:35
RootHistCnv::RRWNTupleCnv::classID
static const CLID & classID()
Inquire class type.
Definition: RRWNTupleCnv.h:22

RootHistCnv::RRWNTupleCnv::~RRWNTupleCnv | ( |  | ) |
| override default

Standard destructor.

## Member Function Documentation

StatusCode RootHistCnv::RRWNTupleCnv::book | ( | const std::string & | desc,
|  | INTuple * | pObject,
|  | TTree *& | tree
| ) |  |
| override protected virtual

Book the N tuple.

Implements RootHistCnv::RNTupleCnv.

Definition at line 16 of file RRWNTupleCnv.cpp.

18 {
19 MsgStream log( msgSvc(), "RRWNTupleCnv" );
20 // Book the tree
21 rtree = new TTree( desc.c_str(), nt->title().c_str() );
22 // Add the branches
23 for ( const auto& i : nt->items() ) {
24 std::string tag = i->name() + rootVarType( i->type() );
25 // add the branch
26 log << MSG::INFO << "ID " << desc << ": added branch: " << i->name() << " / " << tag << endmsg;
27 rtree->Branch( i->name().c_str(), const_cast<void*>( i->buffer() ), tag.c_str() );
28 }
29 log << MSG::INFO << "Booked TTree with ID:" << desc << " \"" << nt->title() << "\"" << endmsg;
30 return StatusCode::SUCCESS;
31 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
StatusCode::SUCCESS
Definition: StatusCode.h:31
Converter::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
Retrieve pointer to message service.
Definition: Converter.cpp:103
std::string
STL class.
std::string::c_str
T c_str(T...args)
MSG::INFO
Definition: IMessageSvc.h:16
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
RootHistCnv::RNTupleCnv::rootVarType
virtual std::string rootVarType(int)
Return ROOT type info:
Definition: RNTupleCnv.cpp:209
Gaudi.Configuration.log
log
Definition: Configuration.py:13

static const CLID& RootHistCnv::RRWNTupleCnv::classID | ( |  | ) |
| inline static

Inquire class type.

Definition at line 22 of file RRWNTupleCnv.h.

22 { return CLID_RowWiseTuple; }

StatusCode RootHistCnv::RRWNTupleCnv::load | ( | TTree * | tree,
|  | INTuple *& | refpObject
| ) |  |
| override protected virtual

Create the transient representation of an object.

Implements RootHistCnv::RNTupleCnv.

Definition at line 59 of file RRWNTupleCnv.cpp.

61 {
62 return StatusCode::FAILURE;
63 }
StatusCode::FAILURE
Definition: StatusCode.h:31

StatusCode RootHistCnv::RRWNTupleCnv::readData | ( | TTree * | rtree,
|  | INTuple * | pObject,
|  | long | ievt
| ) |  |
| override protected virtual

Read N tuple data.

Implements RootHistCnv::RNTupleCnv.

Definition at line 52 of file RRWNTupleCnv.cpp.

54 {
55 return StatusCode::FAILURE;
56 }
StatusCode::FAILURE
Definition: StatusCode.h:31

StatusCode RootHistCnv::RRWNTupleCnv::writeData | ( | TTree * | rtree,
|  | INTuple * | pObject
| ) |  |
| override protected virtual

Write N tuple data.

Implements RootHistCnv::RNTupleCnv.

Definition at line 34 of file RRWNTupleCnv.cpp.

36 {
37 if ( rtree ) {
38 // Fill the tree;
39 rtree->Fill();
40 // Reset the NTuple
41 nt->reset();
42 return StatusCode::SUCCESS;
43 }
44 MsgStream log( msgSvc(), "RRWNTupleCnv" );
45 log << MSG::ERROR << "Attempt to write invalid N-tuple.";
46 if ( nt ) log << nt->title();
47 log << endmsg;
48 return StatusCode::FAILURE;
49 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
Converter::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
Retrieve pointer to message service.
Definition: Converter.cpp:103
MSG::ERROR
Definition: IMessageSvc.h:16
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
Gaudi.Configuration.log
log
Definition: Configuration.py:13

The documentation for this class was generated from the following files:

- RootHistCnv/src/RRWNTupleCnv.h
- RootHistCnv/src/RRWNTupleCnv.cpp